using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

using Leadtools;
using Leadtools.Codecs;
using Leadtools.Demos;
using Leadtools.Demos.Dialogs;
using Leadtools.Controls;
using Leadtools.ImageProcessing;
using Leadtools.ImageProcessing.Effects;
using Leadtools.Drawing;

namespace GIFReversalToolDemo
{
   /// <summary>
   /// Summary description for MainForm.
   /// </summary>
   public class MainForm : System.Windows.Forms.Form
   {
      private System.Windows.Forms.MainMenu _mmMain;
      private System.Windows.Forms.MenuItem _miFile;
      private System.Windows.Forms.MenuItem _miFileOpen;
      private System.Windows.Forms.MenuItem _miFileExit;
      private System.Windows.Forms.MenuItem _miFileSep1;
      private System.Windows.Forms.MenuItem _miHelp;
      private System.Windows.Forms.MenuItem _miHelpAbout;
      private System.Windows.Forms.MenuItem _miFileSave;
      private MenuItem menuItem1;
      private MenuItem pingPongToolStripMenuItem;
      private Leadtools.Controls.RasterPictureBox rasterPictureBox1;
      private IContainer components;
      MemoryStream forwardGif = new MemoryStream();
      MemoryStream reverseGif = new MemoryStream();
      RasterImage forwardImage = null;
      RasterImage reverseImage = null;
      int frameNumber = 0;
      int totalPages;
      int loops = 1;
      string inputFilePath;

      public MainForm( )
      {
         //
         // Required for Windows Form Designer support
         //
         InitializeComponent();

         // Set the properties for the RasterPictureBox
         rasterPictureBox1.SizeMode = RasterPictureBoxSizeMode.Fit;
         rasterPictureBox1.AutoDisposeImage = false;

         RasterPaintProperties paintProperties = rasterPictureBox1.PaintProperties;
         paintProperties.PaintEngine = RasterPaintEngine.GdiPlus;
         rasterPictureBox1.PaintProperties = paintProperties;
      }

      #region Windows Form Designer generated code
      /// <summary>
      /// Required method for Designer support - do not modify
      /// the contents of this method with the code editor.
      /// </summary>
      private void InitializeComponent( )
      {
         this.components = new System.ComponentModel.Container();
         System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
         this._mmMain = new System.Windows.Forms.MainMenu(this.components);
         this._miFile = new System.Windows.Forms.MenuItem();
         this._miFileOpen = new System.Windows.Forms.MenuItem();
         this._miFileSave = new System.Windows.Forms.MenuItem();
         this._miFileSep1 = new System.Windows.Forms.MenuItem();
         this._miFileExit = new System.Windows.Forms.MenuItem();
         this.menuItem1 = new System.Windows.Forms.MenuItem();
         this.pingPongToolStripMenuItem = new System.Windows.Forms.MenuItem();
         this._miHelp = new System.Windows.Forms.MenuItem();
         this._miHelpAbout = new System.Windows.Forms.MenuItem();
         this.rasterPictureBox1 = new Leadtools.Controls.RasterPictureBox();
         this.SuspendLayout();
         // 
         // _mmMain
         // 
         this._mmMain.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this._miFile,
            this.menuItem1,
            this._miHelp});
         // 
         // _miFile
         // 
         this._miFile.Index = 0;
         this._miFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this._miFileOpen,
            this._miFileSave,
            this._miFileSep1,
            this._miFileExit});
         this._miFile.Text = "&File";
         // 
         // _miFileOpen
         // 
         this._miFileOpen.Index = 0;
         this._miFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
         this._miFileOpen.Text = "&Open...";
         this._miFileOpen.Click += new System.EventHandler(this._miFileOpen_Click);
         // 
         // _miFileSave
         // 
         this._miFileSave.Index = 1;
         this._miFileSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
         this._miFileSave.Text = "&Save Reversed...";
         this._miFileSave.Click += new System.EventHandler(this._miFileSave_Click);
         // 
         // _miFileSep1
         // 
         this._miFileSep1.Index = 2;
         this._miFileSep1.Text = "-";
         // 
         // _miFileExit
         // 
         this._miFileExit.Index = 3;
         this._miFileExit.Text = "E&xit";
         this._miFileExit.Click += new System.EventHandler(this._miFileExit_Click);
         // 
         // menuItem1
         // 
         this.menuItem1.Index = 1;
         this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.pingPongToolStripMenuItem});
         this.menuItem1.Text = "&Actions";
         // 
         // pingPongToolStripMenuItem
         // 
         this.pingPongToolStripMenuItem.Index = 0;
         this.pingPongToolStripMenuItem.Text = "&Ping Pong";
         this.pingPongToolStripMenuItem.Click += new System.EventHandler(this.menuItem2_Click);
         // 
         // _miHelp
         // 
         this._miHelp.Index = 2;
         this._miHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this._miHelpAbout});
         this._miHelp.Text = "&Help";
         // 
         // _miHelpAbout
         // 
         this._miHelpAbout.Index = 0;
         this._miHelpAbout.Text = "&About...";
         this._miHelpAbout.Click += new System.EventHandler(this._miHelpAbout_Click);
         // 
         // rasterPictureBox1
         // 
         this.rasterPictureBox1.Dock = System.Windows.Forms.DockStyle.Fill;
         this.rasterPictureBox1.Location = new System.Drawing.Point(0, 0);
         this.rasterPictureBox1.Name = "rasterPictureBox1";
         this.rasterPictureBox1.Size = new System.Drawing.Size(624, 385);
         this.rasterPictureBox1.TabIndex = 0;
         this.rasterPictureBox1.TabStop = false;
         // 
         // MainForm
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
         this.ClientSize = new System.Drawing.Size(624, 385);
         this.Controls.Add(this.rasterPictureBox1);
         this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
         this.Menu = this._mmMain;
         this.Name = "MainForm";
         this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
         this.Text = "GIF Reversal Tool Demo";
         this.FormClosed += new System.Windows.Forms.FormClosedEventHandler(this.MainForm_FormClosed);
         this.Load += new System.EventHandler(this.MainForm_Load);
         this.ResumeLayout(false);

      }
      #endregion

      /// <summary>
      /// The main entry point for the application.
      /// </summary>
      [STAThread]
      static void Main( )
      {
         Support.SetLicense();

         Application.Run(new MainForm());
      }

      /// <summary>
      /// Initialize the Application.
      /// </summary>
      private void MainForm_Load(object sender, System.EventArgs e)
      {
         Messager.Caption = "C# GIF Reversal Tool Demo";
         Text = Messager.Caption;

         rasterPictureBox1.BackColor = Color.DarkGray;
      }

      /// <summary>
      /// Load a new image
      /// </summary>
      private void _miFileOpen_Click(object sender, System.EventArgs e)
      {
         // Reset out global variables
         loops = 1;
         frameNumber = 0;
         rasterPictureBox1.Image = null;
         pingPongToolStripMenuItem.Checked = true;
         using (OpenFileDialog dlg = new OpenFileDialog())
         {
            try
            {
               dlg.Filter = "All Files|*.*;";
               if (dlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
               {
                  if (!string.IsNullOrEmpty(dlg.FileName))
                  {
                     inputFilePath = dlg.FileName;
                  }
               }
            }
            catch (Exception ex)
            {
               MessageBox.Show(ex.Message);
               this.Close();
            }
         }
         if (string.IsNullOrEmpty(inputFilePath))
            return;
         else
         {
            try
            {
               rasterPictureBox1.FrameChanged -= rasterPictureBox1_FrameChanged;
               PlayImage();
            }
            catch (Exception ex)
            {
               MessageBox.Show(ex.Message);
            }
         }
      }

      /// <summary>
      /// save the original image
      /// </summary>
      private void _miFileSave_Click(object sender, System.EventArgs e)
      {
         if (forwardImage != null)
         {
            using (SaveFileDialog dlg = new SaveFileDialog())
            {
               try
               {
                  dlg.Filter = "Gif Files|*.gif";
                  if (dlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                  {
                     using (RasterCodecs codecs = new RasterCodecs())
                     {
                        // Save the reversed Gif
                        codecs.Save(reverseImage, dlg.FileName, RasterImageFormat.Gif, 8);
                     }
                  }
               }
               catch (Exception ex)
               {
                  MessageBox.Show(ex.Message);
               }
            }
         }
         else
         {
            MessageBox.Show("You must open an image before attempting to save");
         }
      }

      /// <summary>
      /// Shutdown
      /// </summary>
      private void _miFileExit_Click(object sender, System.EventArgs e)
      {
         Close();
      }

      /// <summary>
      /// show the about dialog
      /// </summary>
      private void _miHelpAbout_Click(object sender, System.EventArgs e)
      {
         using (AboutDialog aboutDialog = new AboutDialog("GIF Reversal Tool", ProgrammingInterface.CS))
            aboutDialog.ShowDialog(this);
      }

      private void MainForm_FormClosed(object sender, FormClosedEventArgs e)
      {
         if (forwardImage != null)
            forwardImage.Dispose();
         forwardGif.Dispose();
         if (reverseImage != null)
            reverseImage.Dispose();
         reverseGif.Dispose();
      }

      private void menuItem2_Click(object sender, EventArgs e)
      {
         if (pingPongToolStripMenuItem.Checked == true)
            pingPongToolStripMenuItem.Checked = false;
         else
            pingPongToolStripMenuItem.Checked = true;

         if (!string.IsNullOrEmpty(inputFilePath))
         {
            try
            {
               if (!pingPongToolStripMenuItem.Checked)
               {
                  //Set the animation mode to an infinite loop since Ping Pong is not selected
                  rasterPictureBox1.AnimationMode = RasterPictureBoxAnimationMode.Infinite;
                  //Load the input image for an infinite loop since Ping Pong is not selected
                  rasterPictureBox1.Image = forwardImage;
                  rasterPictureBox1.FrameChanged -= rasterPictureBox1_FrameChanged;
               }
               else
               {
                  // Reset out global variables
                  loops = 1;
                  frameNumber = 0;
                  rasterPictureBox1.AnimationMode = Leadtools.Controls.RasterPictureBoxAnimationMode.UseImageGlobalLoop;
                  rasterPictureBox1.Image = forwardImage;

                  //Add the frame changed event to allow the image to "ping pong"
                  rasterPictureBox1.FrameChanged += rasterPictureBox1_FrameChanged;
               }
            }
            catch (Exception ex)
            {
               MessageBox.Show(ex.Message);
            }
         }
      }
      void PlayImage()
      {
         Cursor.Current = Cursors.WaitCursor;
         using (RasterCodecs codecs = new RasterCodecs())
         {
            // Ensure that all pages in the input file are loaded
            codecs.Options.Load.AllPages = true;
            using (CodecsImageInfo imageInfo = codecs.GetInformation(inputFilePath, true))
            {
               // Get/Set the total number of pages in the input file
               totalPages = codecs.GetInformation(inputFilePath, true).TotalPages;
               // Create a new RasterImage to hold out output Gif frames
               using (RasterImage frames = RasterImage.Create(imageInfo.Width, imageInfo.Height, imageInfo.BitsPerPixel, imageInfo.XResolution, RasterColor.White))
               {
                  // If the input file is animated
                  if (imageInfo.Gif.HasAnimationLoop)
                  {
                     RasterImage destination = null;
                     RasterImage previousUnchanged = null;
                     using (RasterImage bg = RasterImage.Create(imageInfo.Gif.AnimationWidth, imageInfo.Gif.AnimationHeight, imageInfo.BitsPerPixel, imageInfo.XResolution, RasterColor.FromKnownColor(RasterKnownColor.Transparent)))
                     {
                        // Loop through each page in the input file
                        for (int i = 1; i < totalPages + 1; i++)
                        {
                           using (RasterImage source = codecs.Load(inputFilePath, i + 1))
                           {
                              // Create the first frame in the Gif based on the animation height/width
                              if (i == 1 && source.AnimationDisposalMethod != RasterImageAnimationDisposalMethod.None)
                              {
                                 destination = codecs.Load(inputFilePath, i);
                                 // Set out most recent image
                                 previousUnchanged = destination.Clone();

                                 using (RasterImage bgTemp = bg.Clone())
                                 {
                                    // If the first fram is smaller than the total size of the animation create the first frame based on the animation width/height and offset
                                    if (imageInfo.Gif.AnimationWidth != imageInfo.Width || imageInfo.Gif.AnimationHeight != imageInfo.Height)
                                    {
                                       // Use the CombineCommand to create the first frame
                                       destination.AddColorToRegion(destination.TransparentColor, RasterRegionCombineMode.SetNot);
                                       CombineCommand cmd1 = new CombineCommand();
                                       cmd1.SourceImage = destination;
                                       cmd1.DestinationRectangle = new LeadRect(destination.AnimationOffset.X, destination.AnimationOffset.Y, destination.Width, destination.Height);
                                       cmd1.SourcePoint = new LeadPoint(0, 0);
                                       cmd1.Flags = CombineCommandFlags.SourceCopy;
                                       cmd1.Run(bgTemp);
                                       destination = bgTemp;
                                    }
                                    // Add the current frame to our output image
                                    frames.AddPage(destination.Clone());
                                 }
                              }
                              // Determine the frame disposal method for the current frame
                              if (source.AnimationDisposalMethod == RasterImageAnimationDisposalMethod.Leave && source.Transparent == true)
                              {
                                 // Ignore transparent pixels
                                 source.AddColorToRegion(source.TransparentColor, RasterRegionCombineMode.SetNot);

                                 // Combine the current animated frame with the last animated frame
                                 CombineCommand cmd = new CombineCommand();
                                 cmd.SourceImage = source;
                                 cmd.DestinationRectangle = new LeadRect(source.AnimationOffset.X, source.AnimationOffset.Y, source.Width, source.Height);
                                 cmd.SourcePoint = new LeadPoint(0, 0);
                                 cmd.Flags = CombineCommandFlags.SourceCopy;
                                 cmd.Run(destination);
                                 destination.AnimationDelay = source.AnimationDelay;
                                 // Add the current frame to our output image
                                 frames.AddPage(destination.Clone());
                                 // Set our most recent image
                                 previousUnchanged = destination.Clone();
                              }
                              // Determine the frame disposal method for the current frame
                              else if (source.AnimationDisposalMethod == RasterImageAnimationDisposalMethod.RestoreBackground && source.Transparent == true)
                              {
                                 // Ignore transparent pixels
                                 source.AddColorToRegion(source.TransparentColor, RasterRegionCombineMode.SetNot);

                                 using (RasterImage bgTemp = bg.Clone())
                                 {
                                    // Combine the currect animated frame with the last animated frame
                                    CombineCommand cmd = new CombineCommand();
                                    cmd.SourceImage = source;
                                    cmd.DestinationRectangle = new LeadRect(source.AnimationOffset.X, source.AnimationOffset.Y, source.Width, source.Height);
                                    cmd.SourcePoint = new LeadPoint(0, 0);
                                    cmd.Flags = CombineCommandFlags.SourceCopy;
                                    cmd.Run(bgTemp);
                                    bgTemp.AnimationDelay = source.AnimationDelay;
                                    // Add the current frame to our output image
                                    frames.AddPage(bgTemp.Clone());
                                    // Set our most recent image
                                    previousUnchanged = bgTemp.Clone();
                                 }
                              }
                              else if (source.AnimationDisposalMethod == RasterImageAnimationDisposalMethod.RestorePrevious && source.Transparent == true)
                              {
                                 // Add the most recent frame to our output image
                                 frames.AddPage(previousUnchanged.Clone());
                              }
                              else
                              {
                                 // Load the current frame
                                 destination = codecs.Load(inputFilePath, i);
                                 // Add the current frame to the output image
                                 frames.AddPage(destination.Clone());
                                 // Set out most recent image
                                 previousUnchanged = destination.Clone();
                              }
                           }
                        }
                     }
                     frames.RemovePageAt(1);

                     destination.Dispose();
                     previousUnchanged.Dispose();

                     // Save the forward GIF
                     forwardImage = frames;
                  }
                  // If the input file is not animated
                  else
                  {
                     // Load the input file
                     forwardImage = codecs.Load(inputFilePath);
                     // Add a small animation delay for easier viewing
                     for (int pagenumber = 1; pagenumber <= forwardImage.PageCount; pagenumber++)
                     {
                        forwardImage.Page = pagenumber;
                        forwardImage.AnimationDelay = 100;
                     }
                     forwardImage.Page = 1;
                  }
                  // Save the output file to a MemoryStream to easily set all the necessary Gif properties
                  codecs.Save(forwardImage, forwardGif, RasterImageFormat.Gif, 8);

                  // Loop through the pages and reverse the page order
                  reverseImage = RasterImage.Create(imageInfo.Width, imageInfo.Height, imageInfo.BitsPerPixel, imageInfo.XResolution, RasterColor.White);
                  for (int inputPage = forwardImage.PageCount; inputPage >= 1; inputPage--)
                  {
                     forwardImage.Page = inputPage;
                     if (forwardImage.AnimationDelay == 0)
                        forwardImage.AnimationDelay = 100;
                     reverseImage.AddPage(forwardImage);
                  }
                  reverseImage.RemovePageAt(1);

                  //Save the reversed GIF file to a MemoryStream to easily set all the necessary Gif properties
                  codecs.Save(reverseImage, reverseGif, RasterImageFormat.Gif, 8);

                  // Set the animation mode for the RasterPictureBox
                  rasterPictureBox1.AnimationMode = Leadtools.Controls.RasterPictureBoxAnimationMode.UseImageGlobalLoop;

                  // Load the images from the MemoryStream where they now have the necessary Gif properties
                  rasterPictureBox1.Image = codecs.Load(forwardGif);
                  forwardImage = codecs.Load(forwardGif);
                  reverseImage = codecs.Load(reverseGif);

                  // Add the frame changed event to allow the image to "ping pong"
                  rasterPictureBox1.FrameChanged += rasterPictureBox1_FrameChanged;

                  // Play the animated Gif
                  rasterPictureBox1.PlayAnimation();
                  Cursor.Current = Cursors.Default;
               }
            }
         }
      }
      private void rasterPictureBox1_FrameChanged(object sender, RasterPictureBoxFrameChangedEventArgs e)
      {
         frameNumber++;
         // Switch images if this is the last frame of the Gif
         if (frameNumber == totalPages)
         {
            loops++;
            try
            {
               if (loops % 2 == 0)
               {
                  //Load the output image for "pong"
                  rasterPictureBox1.Image = reverseImage;
               }
               else
               {
                  //Load the input image for "ping"
                  rasterPictureBox1.Image = forwardImage;
               }
               frameNumber = 0;
            }
            catch (Exception ex)
            {
               MessageBox.Show(ex.Message);
            }
         }
      }
   }
}
